/**
 * Formularanwendung für das Universal Interface Master/Slave
 * FT-Plotter mit 2 Schrittmotoren (an M1/M2 sowie M3/M4) 
 * sowie Stift an O9 (O1 Slave)
 * 
 * Treiber: 
 *   umFish.dll (5.6.2001) umFishCount.dll (19.12.17)
 *   LPT-Treiber: WinRT.sys (6.3.2001)und WinRTSYS.reg
 *   javafish.dll (26.11.17) Wrapper-Datei
 *   ftcomputing.jar (26.11.17) java-Bibliothek mit Klasse JavaFish
 * 
 *   schnelle Tastenabfrage: getKeyState 
 *   schnelle Schrittmotor-Befehle: xstepperZ xstepperV ystepperZ ystepperV
 * Anzeige von Sensorwerten im JFrame (aus javax.swing)
 * Steuerung des Malstiftes über das Ziffernfeld
 * 
 * Skalierbare Ziffern: 1...9 (Q...O) 0(P)-(M),(D) 
 * 
 * Jawtusch 29.11.2017
 */
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import ftcomputing.*;

class List{
    double x;
    double y;
}
public class gFaceRB
{
Frame frmMain ;
JavaFish ui = new JavaFish();
JLabel Com = new JLabel();

JLabel lblStatus = new JLabel("Universal Interface -> FT-Plotter", JLabel.CENTER);
private JLabel lblPosition = new JLabel(" ", JLabel.CENTER);
JLabel lblFarbe = new JLabel(" ", JLabel.CENTER);
JLabel lblSpur = new JLabel("Ziffern: Q..P, M,K ", JLabel.CENTER);
JLabel lblDist = new JLabel(" ", JLabel.CENTER);
JLabel lblTaster = new JLabel(" ", JLabel.CENTER);
JLabel lblgps = new JLabel(" ", JLabel.CENTER);
JLabel lblHinweis = new JLabel(" ", JLabel.CENTER);
JLabel lblHinweis1 = new JLabel(" ", JLabel.CENTER);
JLabel lblHinweis2 = new JLabel(" ", JLabel.CENTER);
JButton butUrsprung = new JButton("setze Ursprung");

int stepperdelay = 12; //ca. 10ms Verzögerung
int px = 0, py = 0;
List[] ziffer = new List[7];
double sg = 9; //Schriftgröße
boolean ftplot = true;
    /**
     * Constructor for objects of class gFaceTX
     */
    public gFaceRB()
    {  for (int k = 0; k < 7; k++) {
          ziffer[k] = new List();}
       frmMain = new JFrame();
       frmMain.setLayout(new GridLayout(0, 1, 12, 24));
       frmMain.setSize(300, 450); 

//frmMain.requestFocus();
    
butUrsprung.addActionListener(new ActionListener() {
       public void actionPerformed(ActionEvent e) {
       px = 0; py = 0; 
       }
     });
frmMain.setTitle("FT-Plotter");     
frmMain.add(Com);
frmMain.add(butUrsprung);
frmMain.add(lblStatus);
frmMain.add(lblPosition);
frmMain.add(lblDist);
frmMain.add(lblTaster);
frmMain.add(lblSpur);
frmMain.add(lblgps);
frmMain.add(lblHinweis);
frmMain.add(lblHinweis1);
frmMain.add(lblHinweis2);
frmMain.setVisible(true);
}     
public static void main(String[] args) {

gFaceRB gf = new gFaceRB();
gf.Action();
}

private void Action() {

butUrsprung.requestFocus();

try {

ui.openInterface("LPT");
  //Verbindung über Parallelport: LPT
Com.setForeground(Color.BLUE);
  Com.setText("   Universal-Interface über LPT1 verbunden");
  lblHinweis.setText("Plotten: '1 2 3 4  6 7 8 9' ");
  lblHinweis1.setText("Stiftab: ','  Stifthoch: '0' ");
  lblHinweis2.setText("Home: '5'  Ende: ESC");

  int Spurl = 0, Spurr = 0;

do {
 lblPosition.setText("Stift-Position: ( " + px + " / " + py + " )");
 lblTaster.setText("Taster I7 / I8 : " + ui.getInput(7) + " / " + ui.getInput(8));
 if(ui.getKeyState(110))
             {ui.setLamp(9,true);}     //Stift ab
  if(ui.getKeyState(96))
             {ui.setLamp(9,false);}    //Stift hoch
       
  if(ui.getKeyState(102))           //if-Kaskade zur Steuerung des Plotter-Stiftes
             {xv();}
   else if(ui.getKeyState(100))
            { xz();}
    else if(ui.getKeyState(98))
            {yz();}
     else if(ui.getKeyState(104))
           {yv();}
      else if (ui.getKeyState(97))
             {xz(); yz();}
       else if(ui.getKeyState(103))
            { xz(); yv();}
        else if(ui.getKeyState(105))
            {xv(); yv();}
         else if(ui.getKeyState(99))
            {xv(); yz();}
          else if(ui.getKeyState(101))
            {home();}
            else if(ui.getKeyState(80))
              {Null(sg);
              }
              else if(ui.getKeyState(77))
              {Minus(sg);
              }
               else if(ui.getKeyState(81))
              {Eins(sg);
              }
              else if(ui.getKeyState(75))
              {Komma(sg);
              }
               else if(ui.getKeyState(87))
              {Zwei(sg);
              }
               else if(ui.getKeyState(69))
              {Drei(sg);
              }
               else if(ui.getKeyState(82))
              {Vier(sg);
              }
               else if(ui.getKeyState(84))
              {Fuenf(sg);
              }
                else if(ui.getKeyState(90))
              {Sechs(sg);
              }
               else if(ui.getKeyState(85))
              {Sieben(sg);
              }
               else if(ui.getKeyState(73))
              {Acht(sg);
              }
              else if(ui.getKeyState(79))
              {Neun(sg);
              }
               else if(ui.getKeyState(89))
              {Zahl(String.valueOf(-3.14));
              }
          else { xaus(); yaus();}
 } while (!ui.finish());  
}
catch (Exception eft) {
lblStatus.setText(eft.toString());}
finally {
  lblHinweis.setForeground(Color.RED);
  lblHinweis.setText("Finito");
  try {Thread.sleep(2000); } 
  catch (InterruptedException localInterruptedException) {  };
ui.closeInterface();
System.exit(0);
}
}

private void xaus() {
    ui.setMotor(1,0); ui.setMotor(2,0);}
private void yaus() {
    ui.setMotor(3,0); ui.setMotor(4,0);}
private void xv() {
    ui.xStepperV(stepperdelay);
    px++;}
private void xz() {
    if (!ui.getInput(7)) {ui.xStepperZ(stepperdelay);
    px--;} else {xaus(); px = 0;}}    
private void yv() {
    ui.yStepperV(stepperdelay);
    py++;}
private void yz() {
    if (!ui.getInput(8)) {ui.yStepperZ(stepperdelay);
    py--;} else {yaus();py = 0;}} 
 private void pd(){   
  ui.setLamp(9,true);}  
  private void pu(){   
  ui.setLamp(9,false);}
private void home() {
     while (!ui.getInput(8) && !ui.finish(6)) {
       if (ui.getKeyState(81) ) {return;}
       yz(); lblPosition.setText("Stift-Position: ( " + px + " / " + py + " )");}
       py = 0;   
     while (!ui.getInput(7)  && !ui.finish(6)) {
       if (ui.getKeyState(81)) {return;}
       xz(); lblPosition.setText("Stift-Position: ( " + px + " / " + py + " )");}
       xaus(); px = 0;
   
       ui.setLamp(12,true); ui.pause(500); ui.setLamp(12,false);
  }
public void moveto (int x, int y){
    if (ftplot) {
    int dx  = x - px; int dy = y - py; int k;
    if (dx > 0) {for (k = 0; k < dx; k++) {xv();if (ui.finish()) return;}}
    if (dx < 0) {for (k = 0; k < -dx; k++) {xz();if (ui.finish()) return;}}
    if (dy > 0) {for (k = 0; k < dy; k++) {yv();if (ui.finish()) return;}}
    if (dy < 0) {for (k = 0; k < -dy; k++) {yz();if (ui.finish()) return;}}
    px = x; py = y; 
    xaus(); yaus();}
}    
private List mul (int k, List u) {
    List op = new List();
    op.x = k*u.x; op.y=k*u.y;
    return op;
}
private int zahl (List p, List z){
    double dx = z.x - p.x;
    double dy = z.y - p.y;
    double r = Math.abs(dx) + Math.abs(dy);
    if (r == 0) r = 1;
    return (int)r;
}
private List richtung (List p, List z){
    int n = zahl (p,z);
    List op = new List();
    op.x = (z.x - p.x) / n;
    op.y = (z.y - p.y) / n;
    return op;
}
public void lineto (int x, int y){
    if (ftplot){
    int vx, vy;
    List u = new List();
    List v = new List();
    List z = new List(); z.x = x; z.y = y;
    List aktp = new List();
    aktp.x = px; aktp.y = py;
    u = richtung (aktp, z);
    int vxalt = 0; int vyalt = 0;
    for (int n=1; n<= zahl(aktp,z); n++) {
     if (ui.finish()) return;   
     v = mul(n,u);
     vx = (int)Math.round(v.x);vy = (int)Math.round(v.y);
     if (vxalt < vx) {xv(); vxalt++;}
     if (vxalt > vx) {xz(); vxalt--;}
     if (vyalt < vy) {yv(); vyalt++;}
     if (vyalt > vy) {yz(); vyalt--;}
    }
    xaus(); yaus();
    px = x; py = y;}
}  
private void raster (int x, int y, double sg) { 
    //berechnet 7 Punkte für 7-Segmentanzeige
    ziffer[0].x = x; ziffer[0].y = y;
    ziffer[1].x = x + sg; ziffer[1].y = y;
    ziffer[2].x = x + sg*0.1; ziffer[2].y = y + sg*1.05;
    ziffer[3].x = x + sg*1.1; ziffer[3].y = y + sg*1.05;
    ziffer[4].x = x + sg*0.2; ziffer[4].y = y + sg*2.1;
    ziffer[5].x = x + sg*1.2; ziffer[5].y = y + sg*2.1;
    ziffer[6].x = x - sg*0.5; ziffer[6].y = y - sg*0.8;
} 
private void lineto(List p) {
    lineto((int)p.x,(int)p.y);
}
private void moveto (List p){
    moveto((int)p.x,(int)p.y);
}
private void Null(double sg) {
    raster(px,py,sg);
    pd();
    lineto(ziffer[4]);
    lineto(ziffer[5]);lineto(ziffer[1]);
    lineto(ziffer[0]); ui.pause(40);
    pu(); moveto( px + (int)Math.round(1.5*sg), py); xaus(); yaus();
}

private void Komma(double sg) {
    int x = px; int y = py;
    moveto( x + (int)Math.round(0.2*sg), y);
    raster(px,py,sg);
    pd();
    lineto(ziffer[6]);ui.pause(40);
    pu(); moveto( x + (int)Math.round(0.7*sg), y);xaus(); yaus();
}
private void Minus(double sg) {
    int x = px; int y = py;
    raster(px,py,sg);  
    moveto(ziffer[2]); 
    pd(); 
    lineto(ziffer[3]);
    lineto(ziffer[2]); ui.pause(40);
    pu(); moveto( x + (int)Math.round(1.5*sg), y);xaus(); yaus();
}
private void Eins(double sg) {
    int x = px; int y = py;
    moveto( x + (int)Math.round(0.2*sg), y);
    raster(px,py,sg);
    pd();
    lineto(ziffer[2]);lineto(ziffer[4]); ui.pause(40);
    pu(); moveto( x + (int)Math.round(0.7*sg), y);xaus(); yaus();
}
private void Zwei(double sg) {
    int x = px; int y = py;
    raster(px,py,sg);  
    moveto(ziffer[4]); 
    pd(); 
    lineto(ziffer[5]);lineto(ziffer[3]);
    lineto(ziffer[2]);lineto(ziffer[0]);
    lineto(ziffer[1]); ui.pause(40);
    pu(); moveto( x + (int)Math.round(1.5*sg), y);xaus(); yaus();
}
private void Drei(double sg) {
    int x = px; int y = py;
    raster(px,py,sg);  
    moveto(ziffer[4]); 
    pd(); 
    lineto(ziffer[5]);lineto(ziffer[3]);
    lineto(ziffer[2]);lineto(ziffer[3]);
    lineto(ziffer[1]); lineto(ziffer[0]);ui.pause(40);
    pu(); moveto( x + (int)Math.round(1.5*sg), y);xaus(); yaus();
}
private void Vier(double sg) {
    int x = px; int y = py;
    raster(px,py,sg); 
    moveto(ziffer[4]); 
    pd(); 
    lineto(ziffer[2]);lineto(ziffer[3]);
    lineto(ziffer[5]);lineto(ziffer[1]);ui.pause(40);
    pu(); moveto( x + (int)Math.round(1.5*sg), y);xaus(); yaus();
}
private void Fuenf(double sg) {
    int x = px; int y = py;
    raster(px,py,sg);
    moveto(ziffer[5]); 
    pd(); 
    lineto(ziffer[4]);lineto(ziffer[2]);
    lineto(ziffer[3]);lineto(ziffer[1]);
    lineto(ziffer[0]);ui.pause(40);
    pu(); moveto( x + (int)Math.round(1.5*sg), y);xaus(); yaus();
}
private void Sechs(double sg) {
    int x = px; int y = py;
    raster(px,py,sg);
    moveto(ziffer[5]); pd(); 
    lineto(ziffer[4]);lineto(ziffer[0]);
    lineto(ziffer[1]);lineto(ziffer[3]);
    lineto(ziffer[2]);ui.pause(40);
    pu(); moveto( x + (int)Math.round(1.5*sg), y);xaus(); yaus();
}
private void Sieben(double sg) {
    int x = px; int y = py;
    raster(px,py,sg);
    moveto(ziffer[2]); pd(); 
    lineto(ziffer[4]);lineto(ziffer[5]);
    lineto(ziffer[1]);ui.pause(40);
    pu(); moveto( x + (int)Math.round(1.5*sg), y);xaus(); yaus();
}
private void Acht(double sg) {
    int x = px; int y = py;
    raster(px,py,sg);
    pd();
    lineto(ziffer[1]);lineto(ziffer[5]);
    lineto(ziffer[4]);lineto(ziffer[2]);
    lineto(ziffer[3]);lineto(ziffer[2]); lineto(ziffer[0]);
    ui.pause(40); pu(); 
    moveto( x + (int)Math.round(1.5*sg), y);xaus(); yaus();
}
private void Neun(double sg) {
    int x = px; int y = py;
    raster(px,py,sg);
    pd(); 
    lineto(ziffer[1]);lineto(ziffer[5]);
    lineto(ziffer[4]);lineto(ziffer[2]);
    lineto(ziffer[3]);ui.pause(40);
    pu(); moveto( x + (int)Math.round(1.5*sg), y);xaus(); yaus();
}
private void druckeInt(String is){
    int ascii;
   for (int j=0; j < is.length(); j++) {
      ascii = (int)is.charAt(j);
      switch (ascii) {
     case 48: Null(sg); break;     
     case 49: Eins(sg); break;
     case 50: Zwei(sg); break;
     case 51: Drei(sg); break;
     case 52: Vier(sg); break;
     case 53: Fuenf(sg); break;
     case 54: Sechs(sg); break;
     case 55: Sieben(sg); break;
     case 56: Acht(sg); break;
     case 57: Neun(sg); break;
          default: break;
        }
    }  
}
public void Zahl(String zs) {
    if (zs.charAt(0) == '-') {Minus(sg); zs = zs.substring(1);}
    if (zs.indexOf('.') > 0) {
    int k = zs.indexOf('.');
    druckeInt(zs.substring(0, k));
    Komma(sg);
    druckeInt(zs.substring(k+1));
    } 
    else druckeInt(zs);
} 
}

